;;; -*- Mode: LISP; Syntax: Common-Lisp; Base: 10; Package: CL-USER -*-

"Copyright (c) 1991 by International Lisp Associates.  All rights reserved."

(in-package "USER")

;;; Now we define the CLIM-STREAM package.

(eval-when (compile load eval)

(clim-lisp::defpackage CLIM-STREAM
    (:use CLIM-LISP CLIM-UTILS CLIM CLIM-SHARED)

  (:shadowing-import-from 
   CLIM-UTILS
   DEFMETHOD DEFUN FLET LABELS DYNAMIC-EXTENT NON-DYNAMIC-EXTENT)

  (:export

   output-protocol-mixin
   encapsulating-stream-mixin
   
   ;; ??? Need to export temporarily, to make all the CI stuff get the right
   ;; symobls for these.  ??? Package stuff is a terrible mess right now --- RR
   
   define-protocol-p-method
   decode-stream-for-writing
   do-text-screen-real-estate
   stream-set-cursor-position*
   stream-cursor-position*
   stream-unread-gesture
   stream-read-gesture
   with-cursor-visibility
   stream-update-region
   stream-glyph-for-character
   stream-output-glyph-buffer
   stream-scan-string-for-writing
   stream-next-tab-column
   stream-draw-lozenged-character
   stream-advance-cursor-line
   stream-handle-line-wrap
   formatting-cell-internal
   
   ;; ??? Output Recording 
   stream-draw-p stream-record-p
   stream-redisplaying-p
   output-recording-stream-output-record 
   output-recording-stream-highlighted-presentation
   output-recording-stream-current-output-record-stack
   output-recording-stream-output-record-absolute-position
   output-recording-stream-redisplay-output-record

   add-character-output-to-output-record
   add-string-output-to-output-record
   add-tab-to-output-record
   add-lozenged-character-output-to-output-record
   close-current-text-output-record
   set-highlighted-presentation

   *input-context*   
   
   ;; ??? logical gestures ???
   keysym-and-shift-mask-member
   )
  
  #+ignore
  (:export
   ;; Stream Proposal
   INPUT-STREAM-P
   OUTPUT-STREAM-P
   OPEN-STREAM-P
   STREAMP
   STREAM-ELEMENT-TYPE
   CLOSE
   PATHNAME
   TRUENAME
   FORMAT
   ;; CL stream input functions
   READ-BYTE
   READ-CHAR
   UNREAD-CHAR
   READ-CHAR-NO-HANG
   PEEK-CHAR
   LISTEN
   READ-LINE
   CLEAR-INPUT
   ;; CL stream output functions
   WRITE-BYTE
   WRITE-CHAR
   WRITE-STRING
   TERPRI
   FRESH-LINE
   FORCE-OUTPUT
   FINISH-OUTPUT
   CLEAR-OUTPUT

   )
  ))


