;;; -*- Mode: LISP; Syntax: ANSI-Common-Lisp; Base: 10; Package: USER; Lowercase: Yes -*-

(in-package #-ansi-90 "USER" #+ansi-90 "COMMON-LISP-USER")

"Copyright (c) 1991 by International Lisp Associates.  All rights reserved.

 Portions derived from CLIM 1.0 file SYS:CLIM;UTILS;PACKAGES.LISP:
   Copyright (c) 1990, 1991 Symbolics, Inc.  All rights reserved.
   Portions copyright (c) 1990, 1991 International Lisp Associates.  All rights reserved."

(clim-lisp:defpackage clim-utils
  (:use	CLIM-LISP)
  
  #+(and ccl-2 ansi-90)
  (:shadow
    char=
    standard-char-p
    graphic-char-p
    alpha-char-p)

  ;; Maybe this should be #-ansi-90?  Since we don't load the DEFUN
  ;; file at all when ANSI is in the features list.
  #-(or ccl-2 excl)
  (:shadow
    defun
    flet labels
    defgeneric defmethod
    #-(and Genera (not Genera-Release-8-0)) dynamic-extent
    #-excl non-dynamic-extent)

  #+(or Lucid excl)
  (:shadow
    with-slots)

  #+Genera (:import-from SYSTEM ARGLIST)
  #+Genera (:import-from ZWEI INDENTATION)

  #+Lucid
  (:import-from 
		#+LCL3.0 LCL
		#-LCL3.0 SYSTEM
   arglist)
  
  #+excl (:import-from excl arglist)

  #|  ;;; Unclear this is the right thing:
  #+(or Genera Allegro)
  (:import-from 
		#+Genera		SYMBOLICS-COMMON-LISP
		#+Allegro		CLTL1
   char-bit
   char-bits
   char-bits-limit
   char-control-bit
   char-font
   char-font-limit
   char-hyper-bit
   char-meta-bit
   char-super-bit
   int-char
   make-char
   set-char-bit
   string-char
   string-char-p)
|#
  ;; --- There's still lots of junk in here from CLIMs 0.9 and 1.0.
  ;; --- After the utilities files are cleaned up, we should go through
  ;; --- this file and clean in up as well.

  (:export
    ;; Declarations only we support
    arglist indentation non-dynamic-extent

    ;; From DEFUN-UTILITIES
    *keyword-package*
    extract-declarations

    ;; From CLIM-UTILITY-MACROS
    default-output-stream default-input-stream default-query-stream
    fintern
    gensymbol with-related-gensymbols
    with-gensyms
    remove-word-from-string
    push-unique
    catch-if
    dovector
    doseq
    dorest
    with-fast-vector-references
    multiple-value-second
    with-collection collect
    letf-globally letf-globally-if
    define-group
    with-warnings-for-definition
    compile-time-warn
    defun-inline
    defun-property
    with-stack-list with-stack-list*
    with-stack-array
    with-rem-keywords
    canonicalize-and-match-lambda-lists
    compile-time-property
    once-only
    bind-to-list
    lambda-list-variables-used-in-body
    parameter-specifier-keyword
    minf maxf minf-or maxf-or roundf
    def-property-slot-macros def-property-slot-accessors	; --- Obsolete??
    unimplemented
    define-unimplemented-protocol-method			; --- Obsolete.
    with-lockf with-recursive-lockf
    without-scheduling

    ;; From CLIM-UTILITY-FUNCTIONS
    funcallable-p
    +string-array-element-type+
    follow-synonym-stream
    evacuate-list
    make-stack-array
    rem-keywords
    real
    boolean
    find-class-that-works
    copy-vector-portion
    simple-vector-push-extend
    simple-vector-insert-element
    integerize-coordinate
    *multiprocessing-p*
    initial-lock-value
    initial-recursive-lock-value
    make-process
    processp
    destroy-process
    current-process
    all-processes
    show-processes
    process-yield
    process-wait
    process-wait-with-timeout
    process-interrupt

    ;; From CLOS
    find-dynamic-class

    ;; From QUEUE
    locking-queue
    make-queue
    queue
    queue-contents-list
    map-over-queue
    queue-contents-type
    queue-empty-p
    queue-flush
    queue-full-p
    queue-get
    queue-last
    queue-length
    queue-next
    queue-pop
    queue-push
    queue-put
    queue-size
    queue-unget
    with-queue-locked

    *outer-self*
    ;; Since we aren't using RSL's new define-protocol stuff yet,
    ;; export from CLIM-UTILS the old PROTOCOL.LISP protocol. -York 9/23/91
    defprotocol defrole defoperation
    define-trampoline-template
    define-slot-trampoline-template
    generate-trampolines

    ;; From AUTOCONSTRUCTOR
    fast-make-instance
    defautoconstructor
    autoconstructor
    disable-autoconstructors
    enable-autoconstructors
    ;; --- experimentally added 9/23/91 doughty
    define-constructor

    ;; From MULTI-VALUE-SETF
    defgeneric*
    defmethod*
    setf*

    ;; --- Doughty added this on 9/24/91.
    ;; From defresource.lisp
    ;; with-resource-rd     ;; used by temporary-string-p --- not exported yet.
    ;; rd-objects os-object ;; used by temporary-string-p
    describe-resource
    clear-resource
    defresource
    allocate-resource
    deallocate-resource
    using-resource
    letf-using-resource
    ;; --- Doughty added the above on 9/24/91.

    ;; --- doughty added these on 12/23/91
    ;; --- after moving temp-strings into utils.
    with-temporary-string
    temporary-string-p ;; ??
    evacuate-temporary-string
    with-temp-substring
    ) ;; end :EXPORT

  ;; Lots of other exports from CLIM-UTILS (e.g., transformation
  ;; functions, region functions, color names) are now exported from
  ;; CLIM instead of CLIM-UTILS.
  
  )
